import mpe.BayesianNetwork;
import mpe.IO;

public abstract class Converter {
	public boolean writeOutput;
	public BayesianNetwork bn;
	public int numEvidence = 10;
	public int numExamples = 10;
	public boolean structured;

	public abstract String outString();

	public void doAll(String[] args) throws Exception{
		if(args.length <= 2 || !(args[2].equals("0") || args[2].equals("1"))){ 
			System.out.println("Please specifiy inFilename and outFilename as arguments, as well as 0 for random nets and 1 for structured nets");
			throw new RuntimeException();		
		}
		
		writeOutput = false;
		String inFilename = args[0];
		String outFilename = args[1].substring(0,args[1].lastIndexOf("."));
		String outExtension = args[1].substring(args[1].lastIndexOf("."), args[1].length());
		structured = args[2].equals("1");
		writeOutput = true;
		
		if(args.length > 3)	writeOutput = false;
		if (writeOutput) System.out.println("Building new BN from " + inFilename);
		bn = new BayesianNetwork(inFilename);
		
		int numDifferentDifficulties = 10;
		int numInstancesEach = 5;
		numEvidence = 10;
		double avgVarsToSamplePerDifficulty = bn.numVars / (numDifferentDifficulties+0.0);
		
		if( structured ) { // instance from Bayes net repository.
//			for(int i=0; i<numDifferentDifficulties; i++){
//				numEvidence = (int) Math.floor(avgVarsToSamplePerDifficulty * i);
//				writeNetwork(outFilename + "-" + (i*100)/numDifferentDifficulties + outExtension);
//			}
			for(int i=0; i<numInstancesEach; i++){
				writeNetwork(outFilename + "-e" + (i+1) + outExtension);
			}
			bn.sampleProbs(false);
			for(int i=0; i<numInstancesEach; i++){

//			for(int i=0; i<numDifferentDifficulties; i++){
//				numEvidence = (int) Math.floor(avgVarsToSamplePerDifficulty * i);
//				writeNetwork(outFilename + "-rand" + (i*100)/numDifferentDifficulties + outExtension);
//			}
				writeNetwork(outFilename + "-rand-e" + (i+1) + outExtension);
			}
		} else {
			for(int i=0; i<numInstancesEach; i++){
				writeNetwork(outFilename + "-rand-e" + (i+1) + outExtension);
			}
			bn.sampleProbs(true);
			for(int i=0; i<numInstancesEach; i++){
				writeNetwork(outFilename + "-struc-e" + (i+1) + outExtension);
			}
		}
	
		if (writeOutput) System.out.println("Done. Exiting converter.");
	}
	
	public void writeNetwork(String outFilename) throws Exception {
		bn.sampleEvidence(numEvidence);
		if (writeOutput) System.out.println("Writing network to " + outFilename);
		IO.write(outFilename, outString());
	}
}
