require "English"
require "cmd_line.rb"

# Example call:
# jb2simple -i <jb_file>
# Converts the file <jb_file> (ending in .jb_bif or .xml) to .simple format
# The only precondition is that Java Bayes can read in the file to start with.
# 
# Example call 2:
# jb2simple -i* <jb_file_dir>
# Converts all .jb_bif and .xml files in directory <jb_file_dir> to .simple format

# #########################
# MAIN: Call convert for specified input_files.
# Converts input files from jb format to new format specified by -nf [default:simple] 
# #########################
conv_jar = "jb_converter.jar"	
input_files = read_in("jb_bif$|xml$")
new_format = "simple" #default value
new_format = read_smth("-nf") if check_arg("-nf")
structure = 1
structure = read_int("-struc", 1)

for infile in input_files
	#==== Create output name.
	out = infile.sub(/\.[^\/]+$/,".#{new_format}") # substitue file extension
	puts "  Converting #{infile} -> #{out}"
	
	#==== Call jb_converter to convert file.	
	call  "java -Xms256m -Xmx256m -cp #{conv_jar} jb2#{new_format} #{infile} #{out} #{structure}"# no_out"
end
