package mpe;

/**
 * Creation date: (20.01.2004 17:58:36)
 * @author Frank Hutter
 */
public class Constraint {
	CSPVariable[] vars;
	int[] values;
	double weight;

	public Constraint(CSPVariable[] constraintVars, int pos, double newWeight) {
		vars = constraintVars;
		weight = newWeight;
		values = new int[vars.length];
		for (int i = vars.length-1; i >= 0; i--) {
			values[i] = pos % vars[i].domainSize;
			pos /= vars[i].domainSize;
		}
		if(pos != 0)
			throw new RuntimeException("Cannot construct constraint for variable " + vars[0] + " and pos " + pos);			
	}
	
	public String toString(){
		String result = "[";
		for (int i = 0; i < vars.length-1; i++) {
			result += vars[i].index + "=" + values[i] + " ";
		}
		result += vars[vars.length-1].index + "=" + values[vars.length-1] + "]";
		
		result += ", " + weight;
		return result;
	}
}
